#ifndef __PADE_APPROXIMANT__
#define __PADE_APPROXIMANT__

#include <iostream>
#include "math/matrix.hh"


using namespace std;



extern void    PadeCoefficients(dcomplex *coeff, const unsigned int n, dcomplex *a, dcomplex *b);
extern dcomplex PadeApproximant(dcomplex z, const dcomplex *a, const dcomplex *b, const unsigned int n);

extern void    PadeCoefficients(dcomplex *coeff, const unsigned int n, const unsigned int m, dcomplex *a, dcomplex *b);
extern dcomplex PadeApproximant(dcomplex z, const dcomplex *a, const dcomplex *b, const unsigned int n, const unsigned int m);


/*

// Wynn's epsilon algorithm: if seq is a sequence of partial sums of a power series
// it corresponds to the Pade' approximant [ {(n+1)/2} / {n/2} ]
// where {x} is the integer part of x
//
template <class T>
T WynnEpsilonAlgorithm(T *seq, unsigned int n, bool *fail=NULL) {
  // sequence seq array size must be at least n+1
  T *E = new T[n+1]; // counterdiagonal
  double huge=1.e300, tiny=1.e-300;
  T a1, a2, diff;
  bool ifail=0;
  //if(n==0) return seq[0];
  E[0] = seq[0];
  for(unsigned int k=1; k<=n; k++) {
    E[k] = seq[k];
    a2 = 0.;
    for(unsigned int j=k; j>0; j--) {
      a1 = a2;
      a2 = E[j-1];
      diff = E[j] - a2;
      if(abs(diff) < tiny) {
	E[j-1] = huge;
	ifail = 1;
      } else 
	E[j-1] = a1 + 1./diff;
    }
  }
  if(fail!=NULL) *fail = ifail;
  T res;
  if(n%2 == 0) res = E[0];
  else res = E[1];
  return res;
}



// Same as above, but specifical for a power series sum_k c_k x^k
// inputs: x and the array of coefficients c_k coeff of at least n+1 elements
//
template <class T, class U>
T PadeEpsilonAlgorithm(T x, U *coeff, unsigned int n, bool *fail=NULL) {
  T *seq = new T[n+1];
  seq[0] = coeff[0];
  for(unsigned int i=1; i<=n; i++) {
    seq[i] = seq[i-1] + coeff[i] * pow(x,(double)i);
  }
  return WynnEpsilonAlgorithm(seq, n, fail);
}

*/

#endif
